'From Squeak3.8 of ''5 May 2005'' [latest update: #6665] on 2 September 2005 at 5:26:19 pm'!
Object subclass: #MorphExtension
	instanceVariableNames: 'locked visible sticky balloonText balloonTextSelector externalName isPartsDonor actorState player eventHandler otherProperties identifier path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Kernel'!

!Object methodsFor: '*NetMorph-testing' stamp: 'mu 5/10/2005 20:25'!
isNmUrl
	^false! !


!Morph methodsFor: '*NetMorph-effects'!
dissolve
	| afterForm beforeForm copyForm morph lead startTime minTime |
	morph _ self topRendererOrSelf.
	beforeForm _ Morph imageAll: morph.
	afterForm _ Morph imageWithout: morph.
	copyForm _ beforeForm deepCopy.
	minTime _ 500.
	startTime _ Time millisecondClockValue.
	0.0
		to: 1.0
		by: 1.0 / 32
		do: [:factor | 
			copyForm _ beforeForm deepCopy.
			copyForm
				copyBits: afterForm
				at: 0 @ 0
				translucent: factor.
			copyForm displayAt: self bounds topLeft.
			Display forceDisplayUpdate.
			lead _ startTime + (factor * 32 - 1 * minTime // 32) - Time millisecondClockValue.
			lead > 10
				ifTrue: [(Delay forMilliseconds: lead) wait]].
	morph visible: false! !


!ImageMorph methodsFor: '*NetMorph-geometry' stamp: 'mu 7/14/2005 21:59'!
scaledToSize: anExtent
	self image: (self image scaledToSize: anExtent)! !


!MorphExtension methodsFor: '*NetMorph-accessing' stamp: 'mu 7/11/2005 21:06'!
basicIdentifier
	^identifier
		! !

!MorphExtension methodsFor: '*NetMorph-accessing' stamp: 'mu 7/13/2005 17:09'!
basicIdentifier: anUUID
	identifier _ anUUID
		! !


!PasteUpMorph methodsFor: '*NetMorph-actions' stamp: 'mu 7/13/2005 16:31'!
flushMorphIdentifierRenameList
	self isWorldMorph ifFalse: [^ self].
	self removeProperty: #NetMorph:IdentifierRenameList! !

!PasteUpMorph methodsFor: '*NetMorph-accessing' stamp: 'mu 7/13/2005 16:31'!
morphIdentifierRenameList
	self isWorldMorph ifFalse: [^nil].
	^self valueOfProperty: #NetMorph:IdentifierRenameList ifAbsentPut: [Dictionary new].
	 ! !

!PasteUpMorph methodsFor: '*NetMorph-options' stamp: 'mu 7/13/2005 17:03'!
morphIdentifierAlreadyAdjusted: aBoolean
	self isWorldMorph ifFalse: [^ self].
	^self setProperty: #NetMorph:MorphIdentifierAlreadyAdjusted toValue: aBoolean == true ! !


!PluggableTextMorph methodsFor: '*NetMorph-override-model access' stamp: 'ka 2/25/2003 18:37'!
getText
	"Retrieve the current model text"
	| newText modelValue |
	getTextSelector == nil
		ifTrue: [^ Text new].
	modelValue _ model perform: getTextSelector.
	newText _ (modelValue respondsTo: #asText)
				ifTrue: [modelValue asText]
				ifFalse: [modelValue asString asText].
	^ newText shallowCopy! !

!PluggableTextMorph methodsFor: '*NetMorph-accessing' stamp: 'mu 7/20/2005 20:34'!
textMorph
	^textMorph! !


!Project methodsFor: '*NetMorph-entering' stamp: 'mu 7/13/2005 17:59'!
inheritAdjustmentFrom: aProject 
	| originalRenameList |
	originalRenameList _ aProject world morphIdentifierRenameList.
	originalRenameList
		keysAndValuesDo: [:oldName :newName | world
				allMorphsDo: [:mo | mo extension
						ifNotNilDo: [:ext | 
							| oldId | 
							oldId _ ext basicIdentifier.
							(oldId notNil
									and: [oldId asString = oldName])
								ifTrue: [ext
										basicIdentifier: (UUID fromString: newName)]]]].
	world flushMorphIdentifierRenameList.
	originalRenameList
		keysAndValuesDo: [:k :v | world morphIdentifierRenameList at: k put: v].
	world morphIdentifierAlreadyAdjusted: true! !


!Project class methodsFor: '*NetMorph-instance creation' stamp: 'MU 1/15/2004 23:16'!
loadFrom: bytes
	| readWriteStream |
	readWriteStream _ (RWBinaryOrTextStream with: bytes) reset.
	^ProjectLoading loadFrom: readWriteStream! !


!ProjectLoading class methodsFor: '*NetMorph-actions' stamp: 'mu 8/24/2005 09:27'!
loadFrom: preStream 
	
	| projStream trusted morphOrList baseChangeSet mgr proj archive |
	preStream isZipArchive 
		ifTrue:[	archive := ZipArchive new readFrom: preStream.
				projStream := self projectStreamFromArchive: archive]
		ifFalse:[projStream := preStream].
	trusted := SecurityManager default positionToSecureContentsOf: projStream.
	trusted ifFalse:[(SecurityManager default enterRestrictedMode) ifFalse:[
		(projStream respondsTo: #close) ifTrue:[projStream close].
		^self]].
	morphOrList := projStream asUnZippedStream.
	
	ResourceCollector current: ResourceCollector new.
	baseChangeSet := ChangeSet current.
	self useTempChangeSet.		"named zzTemp"
	"The actual reading happens here"
	[morphOrList := morphOrList fileInObjectAndCode] ensure: [ | zzTemp |
				ChangeSet  newChanges: baseChangeSet.
				zzTemp := ChangeSorter changeSetNamed: 'zzTemp'.
				zzTemp ifNotNil: [ChangeSorter removeChangeSet: zzTemp]
				].
	mgr := ResourceManager new initializeFrom: ResourceCollector current.
	mgr registerUnloadedResources.
	(projStream respondsTo: #close) ifTrue:[projStream close].
	
	ResourceCollector current: nil.
	
	(morphOrList isKindOf: ImageSegment) ifTrue: [
		proj := morphOrList arrayOfRoots 
			detect: [:mm | mm isKindOf: Project] 
			ifNone: [^self inform: 'No project found in this file' translated].
		proj resourceManager: mgr.
		proj lastDirectory: nil.
		CurrentProjectRefactoring currentBeParentTo: proj.
		
		Smalltalk isMorphic ifFalse: [
				ChangeSorter allChangeSets add: proj changeSet.
				ProjectView openAndEnter: proj.
				"Note: in MVC we get no further than the above"
			].
		
		ChangeSorter allChangeSets add: proj changeSet.
		^ proj
	].

	(morphOrList isKindOf: SqueakPage) ifTrue: [
		morphOrList := morphOrList contentsMorph
	].
	(morphOrList isKindOf: PasteUpMorph) ifFalse: [
		^ self inform: 'This is not a PasteUpMorph or exported Project.' translated
	].
	^(Project newMorphicOn: morphOrList) ! !


!SmalltalkImage methodsFor: '*NetMorph-accessing' stamp: 'mu 12/17/2004 01:29'!
id
	^NmImageId current! !


!String methodsFor: '*NetMorph-converting' stamp: 'mu 1/12/2005 01:43'!
asNmUrl
	^ (self beginsWith: NmUrl protocolIdentifier)
		ifTrue: [self asUrl]
		ifFalse: [NmUrl readFrom: self readStream]! !

!String methodsFor: '*NetMorph-testing' stamp: 'mu 8/18/2005 11:03'!
isAddressString
	^ (self isNmUrlString)
		or: [self isIpAndPortString]! !

!String methodsFor: '*NetMorph-testing' stamp: 'mu 1/12/2005 01:40'!
isIpAndPortString
	"'123.2.3.4:30' isIpAndPortString"
	"'qwerty:30' isIpAndPortString"
	"'nm://123.2.3.499:30' isIpAndPortString"
	| index ipOrHostPart isIp portPart |
	(self occurrencesOf: $: ) = 1 ifFalse: [^false].
	index _ self indexOf: $:.
	ipOrHostPart _ self copyFrom: 1  to: index -1.
	isIp _ (NetNameResolver addressFromString: ipOrHostPart) notNil.
	(isIp isNil and: [isIp occurrencesOf: $.]) ifTrue: [^false].
	portPart _ self copyFrom: index +1 to: self size.
	portPart isAllDigits ifFalse: [^false].
	^true! !

!String methodsFor: '*NetMorph-testing' stamp: 'mu 8/18/2005 11:06'!
isNmUrlString
	^self beginsWith: NmUrl protocolIdentifier
	! !


!SystemDictionary methodsFor: '*NetMorph-accessing' stamp: 'mu 12/17/2004 01:30'!
id
	^SmalltalkImage current id! !


!Url methodsFor: '*NetMorph-testing' stamp: 'mu 4/15/2003 16:39'!
isNmUrl
	^false! !


!Url class methodsFor: '*NetMorph-override-parsing' stamp: 'mu 12/29/2004 22:51'!
absoluteFromText: aString
	"Url absoluteFromText: 'http://chaos.resnet.gatech.edu:8000/docs/java/index.html?A%20query%20#part'" 
	"Url absoluteFromText: 'msw://chaos.resnet.gatech.edu:9000/testbook?top'"
	"Url absoluteFromText: 'telnet:chaos.resnet.gatech.edu'"
	"Url absoluteFromText: 'file:/etc/passwd'"
	"Url absoluteFromText: 'nm://dvorak/auau'" 

	| remainder scheme fragment ind newUrl |

	"trim surrounding whitespace"
	remainder _ aString withBlanksTrimmed.	

	"extract the fragment, if any"
	ind _ remainder indexOf: $#.
	ind > 0 ifTrue: [
		fragment _ remainder copyFrom: ind+1 to: remainder size.
		remainder _ remainder copyFrom: 1 to: ind-1 ].

	"choose class based on the scheme name, and let that class do the bulk of the parsing"
	scheme _ self schemeNameForString: remainder.

	scheme = nil ifTrue: [
		newUrl _ HttpUrl new privateInitializeFromText: remainder ].

	(scheme = 'http') ifTrue: [ newUrl _ HttpUrl new privateInitializeFromText: remainder ].
	(scheme = 'msw') ifTrue: [ newUrl _ MswUrl new privateInitializeFromText: remainder ]. 
	(scheme = 'ftp') ifTrue:[ newUrl _ FtpUrl new privateInitializeFromText: remainder ].
	(scheme = 'file') ifTrue: [newUrl _ FileUrl new privateInitializeFromText: remainder ].
	
	(scheme = NmUrl scheme) ifTrue: [newUrl _ NmUrl new privateInitializeFromText: remainder ].
	
	(scheme = 'browser') ifTrue: [ newUrl _ BrowserUrl new privateInitializeFromText: remainder ].
	(scheme = 'mailto') ifTrue: [ newUrl _ MailtoUrl new privateInitializeFromText: remainder ].
	(scheme = 'sqpkg' and: [Smalltalk includesKey: #KomPackageUrl]) ifTrue: 
		[newUrl _ (Smalltalk at: #KomPackageUrl) new privateInitializeFromText: remainder].
	(scheme = 'sqmap' and: [Smalltalk includesKey: #KomSqueakMapUrl]) ifTrue: 
		[newUrl _ (Smalltalk at: #KomSqueakMapUrl) new privateInitializeFromText: remainder].

	newUrl ifNil: [  newUrl _ GenericUrl new privateInitializeFromText: remainder ].


	"set the fragment"
	newUrl privateFragment: fragment.


	"all done"
	^newUrl! !

